(	
	--globals
	try ( destroyDialog dlgSlicer ) catch()
	global dlgSlicer
	global delObj
	global mymat
		
	global div_X
	global div_Y
	global div_Z
	
	global dist_x
	global dist_y
	global dist_z
	
	global xwidth	
	global ywidth	
	global zwidth	
	
	global BBox

	global minpoint
	global maxpoint

	global div_Aaxis	
	global div_Baxis	
	global div_Caxis
	
	global myX_OrigPos
	global myY_OrigPos	
	global myZ_OrigPos	
	
	global MyStartPosA
	global MyStartPosB
	global MyStartPosC
		

	fn geometryFilter sel = (
		local isGeo=true
		for i in sel while isGeo do (
			isGeo=(superClassOf i == GeometryClass)
			)
			return isGeo
		)
		
	fn compareFN v1 v2 =
	(
	local d =  v2[1]-v1[1]
	case of
		(
			(d < 0.): -1
			(d > 0.): 1
			default: 0
		)
	)
	
	fn snapit obj =  (	
		if obj.verts.count != 0 then (
			newobj = snapshot obj
			newobj.material = mymat
		)
	)
	
	fn MoveSlices obj theAxis theDivisions = (
		modname=(theAxis + "1")
		modnameNext=(theAxis + "2")
		case of (
			(theAxis=="X_"):(						
				obj.modifiers[modname].slice_plane.position.x += dist_x
			if theDivisions>1 then	obj.modifiers[modnameNext].slice_plane.position.x += dist_x
			)
			(theAxis=="Y_"):(
				obj.modifiers[modname].slice_plane.position.y += dist_y
			if theDivisions>1 then	obj.modifiers[modnameNext].slice_plane.position.y += dist_y
			)
			(theAxis=="Z_"):(
				obj.modifiers[modname].slice_plane.position.z += dist_z
			if theDivisions>1 then	obj.modifiers[modnameNext].slice_plane.position.z += dist_z
			)
		)
	)
		
	fn AddSlices obj =(
		if(div_X >2) then maxmodX = 2 else maxmodX=div_x
		
		myX_OrigPos=#()		
		for x=1 to (maxmodX) do (
			modname=("X_" + (x as string))
			addModifier obj (Slicemodifier name:modname)
			obj.modifiers[modname].enabled=false
			obj.modifiers[modname].slice_plane.rotation=quat 0 1 0 1
			objTM=obj.objecttransform
			modTM=getModContextTM  obj obj.modifiers[modname]
			obj.modifiers[modname].slice_plane.position = ((minpoint +[dist_x*x,ywidth/2,zwidth/2]) * modTM * (inverse objTM)) 
			myX_OrigPos[x]= obj.modifiers[modname].slice_plane.position
		)

		if(div_Y >2) then maxmodY = 2 else maxmodY=div_Y
		
		myY_OrigPos=#()		
		for y=1 to (maxmodY) do (
			modname=("Y_" + (y as string))
			addModifier obj (Slicemodifier name:modname)
			obj.modifiers[modname].enabled=false
			obj.modifiers[modname].slice_plane.rotation=quat 1 0 0 -1
			objTM=obj.objecttransform
			modTM=getModContextTM  obj obj.modifiers[modname]
			obj.modifiers[modname].slice_plane.position = ((minpoint +[xwidth/2,dist_y*y,zwidth/2]) * modTM * (inverse objTM)) 
			myY_OrigPos[y]= obj.modifiers[modname].slice_plane.position
		)
		
		if(div_Z >2) then maxmodZ = 2 else maxmodZ=div_Z
		
		myZ_OrigPos=#()			
		for z=1 to (maxmodZ) do (
			modname=("Z_" + (z as string))
			addModifier obj (Slicemodifier name:modname)
			obj.modifiers[modname].enabled=false
			obj.modifiers[modname].slice_plane.rotation=quat 0 0 0 1
			objTM=obj.objecttransform
			modTM=getModContextTM  obj obj.modifiers[modname]
			obj.modifiers[modname].slice_plane.position = ((minpoint +[xwidth/2,ywidth/2,dist_z*z]) * modTM * (inverse objTM)) 
			myZ_OrigPos[z]= obj.modifiers[modname].slice_plane.position
		)
		
		MyStartPosA=execute ("My"+div_Aaxis+"OrigPos")
		MyStartPosB=execute ("My"+div_Baxis+"OrigPos")
		MyStartPosC=execute ("My"+div_Caxis+"OrigPos")		
	)
	
	fn measureBbox obj = (
		BBox=nodeLocalBoundingBox obj
		minpoint=BBox[1]
		maxpoint=BBox[2]
		xwidth=(maxpoint[1]-minpoint[1])
		ywidth=(maxpoint[2]-minpoint[2])
		zwidth=(maxpoint[3]-minpoint[3])
	)

	fn sliceIt Xslice Yslice Zslice keepOriginal = (			
		start = timeStamp()

		with redraw off with undo off (
			max create mode
			mySelection=selection as array
						
			for obj in mySelection do (
				mymat=obj.material
				selectedObj = snapshot obj 
				tmpObj=mesh numverts:1
				attach tmpObj selectedObj
--				meshop.attach tmpObj selectedObj attachMat:#IDToMat
				convertToPoly tmpObj
				polyop.deleteIsoVerts tmpObj		
				--tmpObj.material=m
				selectedObj=tmpObj
				convertToMesh selectedObj
				selectedObj.name = obj.name+ "_sliced"
				delObj=obj.name+ "_sliced"
				ResetPivot selectedObj
				CenterPivot selectedObj
				ResetTransform selectedObj

				measureBbox selectedObj

				myArr=#(#(Xslice,"X_"),#(Yslice,"Y_"),#(Zslice,"Z_"))


				div_X = myArr[1][1]
				div_Y = myArr[2][1]
				div_Z = myArr[3][1]
				div_A = myArr[1][1]
				div_B = myArr[2][1]
				div_C = myArr[3][1]

				div_Aaxis = myArr[1][2]
				div_Baxis = myArr[2][2]
				div_Caxis = myArr[3][2]

				dist_x=xwidth/(div_X+1)
				dist_y=ywidth/(div_Y+1)
				dist_z=zwidth/(div_Z+1)
					
				AddSlices selectedObj

				--start cutting
				for x=1 to (div_A+1) do (
					if(div_A > 0) then (
						modname=(div_Aaxis+ "1")
						modnameNext=(div_Aaxis + "2")			
						if (x== 1) then (
							selectedObj.modifiers[modname].slice_plane.position=MyStartPosA[1] 
							if div_A>1 then selectedObj.modifiers[modnameNext].slice_plane.position=MyStartPosA[2] 
						)	
					
						case of (
							(x != (div_A+1)) : (
								selectedObj.modifiers[modname].enabled=true
								selectedObj.modifiers[modname].Slice_Type=2
								
								if (div_A>1 and x>1) then (
									if(x>2)then MoveSlices selectedObj div_Aaxis Div_A
									selectedObj.modifiers[modname].enabled=true
									selectedObj.modifiers[modname].Slice_Type=3
									selectedObj.modifiers[modnameNext].enabled=true
									selectedObj.modifiers[modnameNext].Slice_Type=2
								) else (
									if (div_A>1) then selectedObj.modifiers[modnameNext].enabled=false
									selectedObj.modifiers[modname].enabled=true
									selectedObj.modifiers[modname].Slice_Type=2
								)
							)
							(x==(div_A+1)) : (		
								if(x>1)then(
									if(div_A>1)then (
										selectedObj.modifiers[modnameNext].enabled=true
										selectedObj.modifiers[modname].enabled=false
										selectedObj.modifiers[modnameNext].Slice_Type=3
									) else (									
										selectedObj.modifiers[modname].enabled=true
										selectedObj.modifiers[modname].Slice_Type=3
									)
								) 
							)
						)
					
						if (div_B ==0 AND div_C==0) then snapit selectedObj
					)
					
					for y=1 to (div_B+1) do (
						if (div_B>0) then (
							modname=(div_Baxis+ "1")
							modnameNext=(div_Baxis + "2")
							
							--grab positions modifiers
							if (y== 1) then (
								selectedObj.modifiers[modname].slice_plane.position=MyStartPosB[1] 
								if (div_B>1) then selectedObj.modifiers[modnameNext].slice_plane.position=MyStartPosB[2] 
							)
							case of (
									(y!=(div_B+1)) :(
										if(div_B>1 and y>1)then(
											if(y>2)then(
												MoveSlices selectedObj div_Baxis div_B
												)
											selectedObj.modifiers[modname].enabled=true
											selectedObj.modifiers[modname].Slice_Type=3
											selectedObj.modifiers[modnameNext].enabled=true
											selectedObj.modifiers[modnameNext].Slice_Type=2
										) else (
											if(div_B>1) then selectedObj.modifiers[modnameNext].enabled=false
											selectedObj.modifiers[modname].enabled=true
											selectedObj.modifiers[modname].Slice_Type=2
											)
								)
								(y==(div_B+1)) :(		
									if(y>1)then(
										if(div_B>1) then(
											selectedObj.modifiers[modnameNext].enabled=true
											selectedObj.modifiers[modname].enabled=false
											selectedObj.modifiers[modnameNext].Slice_Type=3
										)else (
											selectedObj.modifiers[modname].enabled=true
											selectedObj.modifiers[modname].Slice_Type=3
										)
									) 
								)
							)
							if (div_C==0) then snapit selectedObj
						)
							
						for z=1 to (div_C+1) do (
							if (div_C>0) then (
								--selectedObj.modifiers["Mysubst"].enabled=true
								modname=(div_Caxis+ "1")
								modnameNext=(div_Caxis + "2")
								
								--grab positions modifiers
								if (z== 1) then (
									selectedObj.modifiers[modname].slice_plane.position=MyStartPosC[1] 
									if div_C>1 then selectedObj.modifiers[modnameNext].slice_plane.position=MyStartPosC[2] 
								)
								case of (
									(z!=(div_C+1)) : (
										if (div_C>1 and z>1) then (
											if(z>2) then MoveSlices selectedObj div_Caxis div_C
											selectedObj.modifiers[modname].enabled=true
											selectedObj.modifiers[modname].Slice_Type=3
											selectedObj.modifiers[modnameNext].enabled=true
											selectedObj.modifiers[modnameNext].Slice_Type=2
										) else (
											if(div_C>1) then selectedObj.modifiers[modnameNext].enabled=false
											selectedObj.modifiers[modname].enabled=true
											selectedObj.modifiers[modname].Slice_Type=2
										)
									)
									(z==(div_C+1)) : (		
										if (z>1) then (
											if (div_C>1) then (
												selectedObj.modifiers[modnameNext].enabled=true
												selectedObj.modifiers[modname].enabled=false
												selectedObj.modifiers[modnameNext].Slice_Type=3
											) else (										
												selectedObj.modifiers[modname].enabled=true
												selectedObj.modifiers[modname].Slice_Type=3
											)
										) 
									)
								)
								snapit selectedObj
								
							)
						)
					)
				) 
							mydel=getNodeByName delObj
								delete mydel
			)
			if keepOriginal then select mySelection else delete mySelection

			--mydel=execute("$"+delObj)
			
		)
				
		gc()		
		end = timeStamp()
		format "Processing took % seconds\n" ((end - start) / 1000.0)		
	)
	
	rollout dlgSlicer "Slicer" width:110 height:150
	(
		spinner X_Spinner "X Subd: " pos:[30,24] width:62 height:16 type:#integer scale:1 range:[0,1000,12]
		spinner Y_Spinner "Y Subd: " pos:[30,48] width:62 height:16 type:#integer scale:1 range:[0,1000,12]
		spinner Z_Spinner "Z Subd: " pos:[30,72] width:62 height:16 type:#integer scale:1 range:[0,1000,12]
		button btnSlice "Slice!" pos:[10,120] width:80 height:25 enabled:true
		checkbox delOrig "Keep Original" pos:[10,95] width:100 height:16 checked:true


		on btnSlice pressed do (
			gc()
			if selection.count !=0 and geometryFilter (selection) then (
				sliceIt X_Spinner.value Y_Spinner.value Z_Spinner.value delOrig.checked
			) else messageBox "no objects selected or non poly/mesh object"
		)
	)
		
	createdialog dlgSlicer
)